/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
	"fmt"
)

// FlowOperationLimit - struct for FlowOperationLimit
type FlowOperationLimit struct {
	FlowOperationLimit *FlowOperationLimit
}

// FlowOperationLimitAsFlowOperationLimit is a convenience function that returns FlowOperationLimit wrapped in FlowOperationLimit
func FlowOperationLimitAsFlowOperationLimit(v *FlowOperationLimit) FlowOperationLimit {
	return FlowOperationLimit{
		FlowOperationLimit: v,
	}
}

// Unmarshal JSON data into one of the pointers in the struct
func (dst *FlowOperationLimit) UnmarshalJSON(data []byte) error {
	var err error
	// this object is nullable so check if the payload is null or empty string
	if string(data) == "" || string(data) == "{}" {
		return nil
	}

	match := 0
	// try to unmarshal data into FlowOperationLimit
	err = newStrictDecoder(data).Decode(&dst.FlowOperationLimit)
	if err == nil {
		jsonFlowOperationLimit, _ := json.Marshal(dst.FlowOperationLimit)
		if string(jsonFlowOperationLimit) == "{}" { // empty struct
			dst.FlowOperationLimit = nil
		} else {
			match++
		}
	} else {
		dst.FlowOperationLimit = nil
	}

	if match > 1 { // more than 1 match
		// reset to nil
		dst.FlowOperationLimit = nil

		return fmt.Errorf("data matches more than one schema in oneOf(FlowOperationLimit)")
	} else if match == 1 {
		return nil // exactly one match
	} else { // no match
		return fmt.Errorf("data failed to match schemas in oneOf(FlowOperationLimit)")
	}
}

// Marshal data from the first non-nil pointers in the struct to JSON
func (src FlowOperationLimit) MarshalJSON() ([]byte, error) {
	if src.FlowOperationLimit != nil {
		return json.Marshal(&src.FlowOperationLimit)
	}

	return nil, nil // no data in oneOf schemas
}

// Get the actual instance
func (obj *FlowOperationLimit) GetActualInstance() interface{} {
	if obj == nil {
		return nil
	}
	if obj.FlowOperationLimit != nil {
		return obj.FlowOperationLimit
	}

	// all schemas are nil
	return nil
}

type NullableFlowOperationLimit struct {
	value *FlowOperationLimit
	isSet bool
}

func (v NullableFlowOperationLimit) Get() *FlowOperationLimit {
	return v.value
}

func (v *NullableFlowOperationLimit) Set(val *FlowOperationLimit) {
	v.value = val
	v.isSet = true
}

func (v NullableFlowOperationLimit) IsSet() bool {
	return v.isSet
}

func (v *NullableFlowOperationLimit) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFlowOperationLimit(val *FlowOperationLimit) *NullableFlowOperationLimit {
	return &NullableFlowOperationLimit{value: val, isSet: true}
}

func (v NullableFlowOperationLimit) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFlowOperationLimit) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
